#
# This test requires gallery to run
#
import __fiber__
import unittest
from test import test_support
import parser
from EasyExtend.csttools import*
import symbol

FiberTransformer = __fiber__.FiberTransformer
PyGrammar        = __fiber__.parsetable
unparse          = __fiber__.unparse

class TestMacro1(unittest.TestCase):
    def runTest(self):pass
    def setUp(self):
        source ="""
        while 1:
            print "Some statement"
            if True:
                break
        """
        self.source = prepare_source(source)
        self.source_node = parser.suite(self.source).tolist()
        _while_stmt = find_node(self.source_node,symbol.while_stmt)
        _stmts      = find_all(_while_stmt,symbol.stmt,level=1)
        _if_stmt = _stmts[-1]
        _stmt = _stmts[:-1]
        self.sym_node = {}
        self.sym_node["suite"] = _stmt[0]
        self.sym_node["test"] = find_node(_if_stmt, symbol.test)


    def test_trivial1(self):
        target = "\n<suite>"
        cst = macro(target).expand(self.sym_node)
        print unparse(cst, pprint=True)


    def test_trivial2(self):
        target = "<test>"
        cst = macro(target).expand(self.sym_node)
        print unparse(cst, pprint=True)


    def test_reproduce1(self):
        target = """
        while 1:
            <suite>
            if <test>:
                break
        """
        cst = macro(target).expand(self.sym_node)
        print unparse(cst, pprint=True)


    def test_reproduce2(self):
        '''
        Reproduce original statement with option.
        '''

        target = """
        if x:
            print "bla"
        optional i in range(1):
            elif SELECT == <test>:
                while 1:
                    <suite>
        """
        cst = macro(target).expand(self.sym_node)
        print unparse(cst, pprint=True)


    def test_nested_option(self):
        '''
        Reproduce original statement with option.
        '''

        target = """
        if x:
            print "bla"
        optional i in range(1):
            elif SELECT == <test>:
                if x<2:
                   print "blubb"
                optional i in range(1):
                    else:
                        while 1:
                            <suite>

        """
        cst = macro(target).expand(self.sym_node)
        print unparse(cst, pprint=True)


    def test_nested_option_with_end_suite(self):
        '''
        Reproduce original statement with option.
        '''

        target = """
        if x:
            print "bla"
        optional i in range(1):
            elif SELECT == <test>:
                if x<2:
                   print "blubb"
                optional i in range(1):
                    else:
                        while 1:
                            <suite>
                <suite>
        <suite>
        """
        cst = macro(target).expand(self.sym_node)
        print unparse(cst, pprint=True)



if __name__ == "__main__":
    tm1 = TestMacro1()
    tm1.setUp()
    tm1.test_reproduce2()

