#
# This test requires gallery to run
#

from EasyExtend.fibers.macro.fiber import*
import EasyExtend.fibers.macro.fiber as __fiber__
import unittest
from test import test_support
import parser
from EasyExtend.csttools import*
from EasyExtend.eecompiler import EECompiler
import symbol

class TestMacro2(unittest.TestCase):
    def runTest(self):pass
    def setUp(self):
        source ="""
        def f(x):
            if x<0:
               print -x
            elif x==0:
               print -1
            else:
               print x
        """
        self.source = prepare_source(source)
        self.source_node = parser.suite(self.source).tolist()
        _if_stmt = find_node(self.source_node, symbol.if_stmt)
        _test  = find_all(_if_stmt, symbol.test)
        _suite = find_all(_if_stmt, symbol.suite)
        self.sym_node = {}
        self.sym_node["suite"] = _suite
        self.sym_node["test"]  = _test


    def test_cit1(self):
        source = """
        \n(cit <test>)
        """
        cst = macro(source).expand(self.sym_node)
        print unparse(cst)
        #code = EasyExtend.eecompiler.eecompile_cst(cst)


    def test_cit2(self):
        source = """
        \n(cit <test>[0])
        """
        cst = macro(source).expand(self.sym_node)
        print unparse(cst)



    def test_cit3(self):
        source = """
        \n(cit <test>[3])-1
        """
        cst = macro(source).expand(self.sym_node)
        print unparse(cst)


    def test_cit4(self):
        source = """
        if x ==1:
            (cit <test>[3])-1
        else:
            (cit <suite>[1])
        """
        cst = macro(source).expand(self.sym_node)
        print unparse(cst)


    def test_cit5(self):
        source = "(cit len(<suite>))"

        cst = macro(source).expand(self.sym_node)
        print unparse(cst)


    def test_reproduce(self):
        source ="""
        def f(x):
            if (cit <test>[0]):
               (cit <suite>[0])
            elif (cit <test>[2]):
               (cit <suite>[1])
            else:
               (cit <suite>[2])
        """
        cst = macro(source).expand(self.sym_node)
        print unparse(cst)


    def test_len_test(self):
        source = """
        l = []
        for item in range(cit len(<test>)):
            l.append(item)
        """
        cst = macro(source).expand(self.sym_node)
        print unparse(cst)
        code = EECompiler(__fiber__).eecompile_cst(cst)
        exec code
        self.assertEqual(l,range(5))


def test_main():
    test_support.run_unittest(TestMacro2)

if __name__ == "__main__":
    test_main()

