########################################################################
#
#                 Language configuration
#
########################################################################

# --- unique fiber offset ---
# Warning! do not touch this. It will be automatically generated by fs.py

FIBER_OFFSET = 3072

# modules and functions

import os
import sys

from optparse import OptionParser

import fibermod.symbol as symbol
import fibermod.token as token

token.FIBER_OFFSET = FIBER_OFFSET
token.FiberToken().gen_token(token)


# modules and functions parametrized by symbol and token

import EasyExtend       # EasyExtend package
import parsetable       # contains fiber specific DFA tables used by the parser
from EasyExtend.eetransformer import Transformer, transform
from EasyExtend.cst2source import Unparser
from EasyExtend.csttools import pprint
from EasyExtend.eecommon import getoptions

from EasyExtend.fstools import FSConfig
FSConfig.fiber_table.append( {"offset":FIBER_OFFSET, "symbol": symbol, "token":token} )

opt = getoptions()
opt.add_option("--pm","--path_mode",dest="path_mode", help="set path mode. options are 'native' and 'common'" )
unparse = Unparser(symbol, token, offset = FIBER_OFFSET)

# add Fibers dir to sys.path

sys.path.append((os.sep).join(symbol.__file__.split(os.sep)[:-3]))

# prompt

prompt = "--> "

# thin fiber

thin_fiber = True

########################################################################


