from EasyExtend.eetoken import*
import os

COMMON_PATH = "COMMON"
NATIVE_PATH = "NATIVE"

class FiberToken(EEToken):
    def __new__(cls):
        EEToken.__new__(cls)
        cls.PATH_MODE = COMMON_PATH
        cls.Separator = cls.DOT[0]
        cls.SIGIL = (102, '$', SPECIAL)
        cls.FAT_TOKEN = (103,'(?P<fat_token>(\\\\\$|\\\\\(|\\\\\)|\\\\\{|\\\\\}|\\\\\+|\\\\\,|[^$(){}.+/,\t\n\r\f\v])+)', FAT_MODE)
        cls.BACKSLASH = (104,'\\',OPERATOR)
        cls.NoNumber = True
        return cls

    @classmethod
    def SetFat(cls, MODE):
        cls.PATH_MODE = MODE
        if cls.PATH_MODE == COMMON_PATH:
            cls.FAT_TOKEN = (103,'(?P<fat_token>(\\\\\$|\\\\\(|\\\\\)|\\\\\{|\\\\\}|\\\\\+|\\\\\,|[^$(){}.+/,\t\n\r\f\v])+)', FAT_MODE)
            cls.Separator = "."
        else:
            if os.sep == "\\":
                cls.Separator = cls.BACKSLASH[0]
                cls.FAT_TOKEN = (103,'(?P<fat_token>(/$|/(|/)|/{|/}|/+|/,|[^\\\$(){}+/,\t\n\r\f\v])+)', FAT_MODE)
                cls.NoContStr = True
            elif os.sep == "/":
                cls.FAT_TOKEN = (103,'(?P<fat_token>(\\\\\$|\\\\\(|\\\\\)|\\\\\{|\\\\\}|\\\\\+|\\\\\,|[^$(){}+/,\t\n\r\f\v])+)', FAT_MODE)
                cls.Separator = cls.SLASH[0]


def change_path_mode(MODE):
    if MODE == FiberToken.PATH_MODE:
        pass
    else:
        FiberToken.SetFat(MODE)
        import token
        token.TOKEN_MAP = {"<>":29+token.FIBER_OFFSET}
        token.tok_name = {}
        EEToken.gen_token(token)
        setattr(token,"Separator", FiberToken.Separator)




