import unittest
from test import test_support
import EasyExtend.path as path

class AllTest(unittest.TestCase):
    def setUp(self):
        import os
        import test_all
        setup_path = path.path((os.sep).join(test_all.__file__.split(os.sep)[:-1]))
        files = path.path(setup_path).files()
        self.test_modules = []
        for f in files:
            name = f.basename()
            if name.startswith(u"test_"):
                if name not in (u'test_all.py', u'test_support.py') and not f.ext == u'.pyc':
                    self.test_modules.append(f.namebase)


    def check(self, module):
        exec "import %s; %s.test_main()"%(module, module)

    def test_all(self):
        for module in self.test_modules:
            self.check(module)


def test_main():
    test_support.run_unittest(AllTest)

if __name__ == "__main__":
    test_main()
